//
//  PlainRacesTableViewController.swift
//  PokedexNC
//
//  Created by Santiago Pavón Gómez on 29/11/16.
//  Copyright © 2016 UPM. All rights reserved.
//

import UIKit

class PlainRacesTableViewController: UITableViewController {
    
    // Asigno esta variable desde AppDelegate
    var pokedexModel: PokedexModel!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    // MARK: - Table view data source
    
    override func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
    
    override func tableView(_ tableView: UITableView,
                            numberOfRowsInSection section: Int) -> Int {
        return pokedexModel.races.count
    }
    
    override func tableView(_ tableView: UITableView,
                            cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "Race Cell",
                                                 for: indexPath)
        
        let race = pokedexModel.races[indexPath.row]
        
        cell.imageView?.image = UIImage(named: race.icon)
        cell.textLabel?.text = race.name
        cell.detailTextLabel?.text = race.code
        
        return cell
    }
    
    
    // MARK: - Navigation
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        if segue.identifier == "Show Web Info" {
            
            // sender es la celda de la tabla que disparo el segue.
            if let wvc = segue.destination as? WebViewController,
                let cell = sender as? UITableViewCell,
                let ip = tableView.indexPath(for: cell) {
                                
                wvc.race = pokedexModel.races[ip.row]
            }
        }
    }

}
