//
//  TypesTableViewController.swift
//  Pokedex
//
//  Created by Santiago Pavón Gómez on 30/9/16.
//  Copyright © 2016 UPM. All rights reserved.
//

import UIKit

class TypesTableViewController: UITableViewController {

    // Asigno esta variable desde AppDelegate
    var pokedexModel: PokedexModel!
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }

    override func tableView(_ tableView: UITableView,
                            numberOfRowsInSection section: Int) -> Int {
        return pokedexModel.types.count
    }

    override func tableView(_ tableView: UITableView,
                            cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "Type Cell",
                                                 for: indexPath)

        let type = pokedexModel.types[indexPath.row]
        
        cell.textLabel?.text = type.name
        
        return cell
    }

   
    

    // MARK: - Navigation

    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        
        if segue.identifier == "Show Races" {
            
            // sender es la celda de la tabla que disparo el segue.
            if let rttvc = segue.destination as? RacesOfTypeTableViewController,
                let cell = sender as? UITableViewCell,
                let ip = tableView.indexPath(for: cell) {
                
                let type = pokedexModel.types[ip.row]
                
                rttvc.races = type.races
                rttvc.typeName = type.name

            }
        }
    }

}
